# -*- coding: iso-8859-1 -*-
#------------------------------------------------------------
# mywebtv - XBMC Plugin
# Canal Thehaine
# http://blog.tvalacarta.info/plugin-xbmc/mywebtv/
#------------------------------------------------------------

import urlparse,urllib2,urllib,re
import os
import sys
import xbmc
import xbmcgui
import xbmcplugin
import scrapertools
import binascii
import xbmctools

try:
	pluginhandle = int( sys.argv[ 1 ] )
except:
	pluginhandle = ""

xbmc.output("[thehaine.py] init")

DEBUG = True
CHANNELNAME = "TheHaine"
CHANNELCODE = "thehaine"

def mainlist(params,url,category):
	xbmc.output("[thehaine.py] mainlist")

	# Aade al listado de XBMC
	xbmctools.addnewfolder( CHANNELCODE , "todos" , CHANNELNAME , "Todos los canales" , "http://www.thehaine.net/search/label/TDTonlineEspa%C3%B1a" , "" , "" )

	# Cierra el directorio
	xbmcplugin.setPluginCategory( handle=pluginhandle, category=category )
	xbmcplugin.addSortMethod( handle=pluginhandle, sortMethod=xbmcplugin.SORT_METHOD_NONE )
	xbmcplugin.endOfDirectory( handle=pluginhandle, succeeded=True )

def todos(params,url,category):
	xbmc.output("[thehaine.py] todos")

	# --------------------------------------------------------
	# Descarga la pgina
	# --------------------------------------------------------
	data = scrapertools.cachePage(url)
	#xbmc.output(data)

	# --------------------------------------------------------
	# Extrae los paises
	# --------------------------------------------------------
	patron = '<td><a href="([^"]+)"><img class="streamlogo" src="([^"]+)" alt="([^"]+)"'
	matches = re.compile(patron,re.DOTALL).findall(data)
	if DEBUG: scrapertools.printMatches(matches)

	for match in matches:
		scrapedtitle = match[2].strip()
		scrapedurl = match[0]
		scrapedthumbnail = match[1]
		scrapedplot = scrapedurl
		if (DEBUG): xbmc.output("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

		# Aade al listado de XBMC
		if not scrapedurl.startswith("http://vertdtgratis"):
			xbmctools.addnewvideo( CHANNELCODE , "play" , CHANNELNAME , "" , scrapedtitle , scrapedurl , scrapedthumbnail, scrapedplot )

	# Cierra el directorio
	xbmcplugin.setPluginCategory( handle=pluginhandle, category=category )
	xbmcplugin.addSortMethod( handle=pluginhandle, sortMethod=xbmcplugin.SORT_METHOD_NONE )
	xbmcplugin.endOfDirectory( handle=pluginhandle, succeeded=True )

def play(params,url,category):
	xbmc.output("[thehaine.py] play")

	title = unicode( xbmc.getInfoLabel( "ListItem.Title" ), "utf-8" )
	thumbnail = urllib.unquote_plus( params.get("thumbnail") )
	plot = unicode( xbmc.getInfoLabel( "ListItem.Plot" ), "utf-8" )
	server = "Directo"
	
	xbmctools.playvideo(CHANNELNAME,server,url,category,title,thumbnail,plot)
